"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadPageContext = exports.isLocalhost = void 0;
var misc_1 = require("./misc");
exports.isLocalhost = Boolean(window.location.hostname === 'localhost' ||
    window.location.hostname === '[::1]' ||
    window.location.hostname.match(/^127(?:\.(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){3}$/));
var loadPageContext = function (proxyEndpoint, timeout, tries) {
    if (timeout === void 0) { timeout = 100; }
    if (tries === void 0) { tries = 50; }
    return __awaiter(void 0, void 0, void 0, function () {
        var apiEndpoint_1, getWebInfo, getSiteInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (typeof _spPageContextInfo !== 'undefined') {
                        return [2, _spPageContextInfo];
                    }
                    if (exports.isLocalhost) {
                        apiEndpoint_1 = proxyEndpoint || window.location.origin;
                        getWebInfo = function () {
                            var restUrl = (0, misc_1.trimMultiline)("\n        ".concat(apiEndpoint_1, "/_api/web?\n          $select=Title,Language,ServerRelativeUrl,Url,\n            CurrentUser/Id,CurrentUser/LoginName,CurrentUser/Email,CurrentUser/Title,CurrentUser/IsSiteAdmin&\n          $expand=CurrentUser\n      "));
                            return fetch(restUrl, {
                                method: 'GET',
                                headers: [
                                    ['Accept', 'application/json;odata=verbose'],
                                    ['X-ProxyStrict', 'false']
                                ]
                            }).then(function (res) { return res.json(); });
                        };
                        getSiteInfo = function () {
                            var restUrl = "".concat(apiEndpoint_1, "/_api/site?$select=ServerRelativeUrl,Url");
                            return fetch(restUrl, {
                                method: 'GET',
                                headers: [
                                    ['Accept', 'application/json;odata=verbose'],
                                    ['X-ProxyStrict', 'false']
                                ]
                            }).then(function (res) { return res.json(); });
                        };
                        return [2, Promise.all([getWebInfo(), getSiteInfo()]).then(function (_a) {
                                var webInfo = _a[0].d, siteInfo = _a[1].d;
                                var _spPageContextInfoFake = {
                                    webTitle: webInfo.Title,
                                    webAbsoluteUrl: apiEndpoint_1 + webInfo.ServerRelativeUrl,
                                    webServerRelativeUrl: webInfo.ServerRelativeUrl,
                                    currentLanguage: webInfo.Language,
                                    siteAbsoluteUrl: apiEndpoint_1 + siteInfo.ServerRelativeUrl,
                                    siteServerRelativeUrl: siteInfo.ServerRelativeUrl,
                                    userId: webInfo.CurrentUser.Id,
                                    userLoginName: webInfo.CurrentUser.LoginName,
                                    userDisplayName: webInfo.CurrentUser.Title,
                                    userEmail: webInfo.CurrentUser.Email,
                                    isSiteAdmin: webInfo.CurrentUser.IsSiteAdmin,
                                    __webAbsoluteUrl: webInfo.Url,
                                    __siteAbsoluteUrl: siteInfo.Url,
                                };
                                window
                                    ._spPageContextInfo = _spPageContextInfoFake;
                                return _spPageContextInfoFake;
                            })];
                    }
                    SP.SOD.executeFunc('sp.js', 'SP.ClientContext', function () { });
                    return [4, (0, misc_1.waitForCondition)(function () { return typeof _spPageContextInfo !== 'undefined'; }, timeout, tries)];
                case 1:
                    _a.sent();
                    return [2, _spPageContextInfo];
            }
        });
    });
};
exports.loadPageContext = loadPageContext;
//# sourceMappingURL=env.js.map